import peasy.*;
PeasyCam cam;
import controlP5.*;
ControlP5 cp5;

Table countTable;
Table table2007;
Table table2008;
Table table2009;
Table table2010;
Table table2011;
Table table2012;
Table table2013;
Table table2014;
Table table2015;
Table table2016;
Table table2017;
Table table2018;
Table table2019;

ArrayList<Day> days;
ArrayList<Day> days2007;
ArrayList<Day> days2008;
ArrayList<Day> days2009;
ArrayList<Day> days2010;
ArrayList<Day> days2011;
ArrayList<Day> days2012;
ArrayList<Day> days2013;
ArrayList<Day> days2014;
ArrayList<Day> days2015;
ArrayList<Day> days2016;
ArrayList<Day> days2017;
ArrayList<Day> days2018;
ArrayList<Day> days2019;

ArrayList<ArrayList <Day>> allArrays;

PFont f;
PFont fA;

int yearMove = 0;

String [] month = {"JAN","FEB","MAR","APR","MAY","JUN",
"JUL","AUG","SEP","OCT","NOV","DEC"};

void setup() {
  size(1800, 1800, P3D);
  //fullScreen(P3D);
  cam = new PeasyCam(this, 225);
  cam.setMinimumDistance(225);
  cam.setMaximumDistance(5000);
  
  smooth();
  
  f = createFont("Apple-Chancery", 60);
  fA = createFont("Baskerville", 60);
  //fA = createFont("AvenirNext-DemiBoldItalic", 60);
  println(PFont.list());
  
  days = new ArrayList <Day>();
  days2007 = new ArrayList <Day>();
  days2008 = new ArrayList <Day>();
  days2009 = new ArrayList <Day>();
  days2010 = new ArrayList <Day>();
  days2011 = new ArrayList <Day>();
  days2012 = new ArrayList <Day>();
  days2013 = new ArrayList <Day>();
  days2014 = new ArrayList <Day>();
  days2015 = new ArrayList <Day>();
  days2016 = new ArrayList <Day>();
  days2017 = new ArrayList <Day>();
  days2018 = new ArrayList <Day>();
  days2019 = new ArrayList <Day>();
  allArrays = new ArrayList <ArrayList<Day>>();
  
  fillTables ("AllData.csv", countTable, days);
  fillTables ("table2007.csv", table2007, days2007);
  fillTables ("table2008.csv", table2008, days2008);
  fillTables ("table2009.csv", table2009, days2009);
  fillTables ("table2010.csv", table2010, days2010);
  fillTables ("table2011.csv", table2011, days2011);
  fillTables ("table2012.csv", table2012, days2012);
  fillTables ("table2013.csv", table2013, days2013);
  fillTables ("table2014.csv", table2014, days2014);
  fillTables ("table2015.csv", table2015, days2015);
  fillTables ("table2016.csv", table2016, days2016);
  fillTables ("table2017.csv", table2017, days2017);
  fillTables ("table2018.csv", table2018, days2018);
  fillTables ("table2019.csv", table2019, days2019);
  
  allArrays.add(days2007);
  allArrays.add(days2008);
  allArrays.add(days2009);
  allArrays.add(days2010);
  allArrays.add(days2011);
  allArrays.add(days2012);
  allArrays.add(days2013);
  allArrays.add(days2014);
  allArrays.add(days2015);
  allArrays.add(days2016);
  allArrays.add(days2017);
  allArrays.add(days2018);
  allArrays.add(days2019);
  
}

void fillTables (String tablePath, Table table, ArrayList <Day> daysArray) {
  table = loadTable (tablePath, "header");
  int numRows = table.getRowCount();
  
  for (int i=0; i < numRows; i++) {
    int month = (table.getInt(i,0));
    int day = (table.getInt(i,1));
    int year = (table.getInt(i,2));
    int rain = (table.getInt(i,3));
    int water = (table.getInt(i,4));
    int river = (table.getInt(i,5));
    int lake = (table.getInt(i,6));
    int ocean = (table.getInt(i,7));
    int sea = (table.getInt(i,8));
    float precip = (table.getFloat(i,11));
    
    Day newDay = new Day (month, day, year, rain, water, 
    river, lake, ocean, sea, precip);
    daysArray.add(newDay);
    
  }  
}


void draw () {
  background (0);
  
  interaction();
  
  if (isolateYear == true) {
    pushMatrix();
    translate(0,0,-20);
    fill(0);
    stroke(0);
    box(150, 150, 5);
    popMatrix();
  }
  
  stroke (255, 255);
  strokeWeight(1);
  noFill();
  
  int r= 150;
  float inc = TWO_PI/12.0;
  for(int i=0;i < 12;i++){
    pushMatrix();
    line(0.48*r*cos(i*inc),0.48*r*sin(i*inc),0,0.5*r*cos(i*inc),0.5*r*sin(i*inc),0);
    popMatrix();
    pushMatrix();
    translate(0.5*r*cos(i*inc),0.5*r*sin(i*inc),0);
    rotateZ(i*inc);
    textAlign(LEFT,CENTER);
    textFont(f,6);
    fill(255);
    text(month[i],10,0,0);
    popMatrix();
  }
  
  if (showTitle == true) {
    pushMatrix();
    translate (-250, -185, -5);
    textAlign(LEFT,CENTER);  
    fill(255);
    textFont(fA,5);
    text("CORRELATION OF PRECIPITATION WITH CHECKOUTS OF BOOKS ABOUT WATER "+"\n"+"SEATLE PUBLIC LIBRIARY"+"\n" +"2007-2019",80,80);
    popMatrix();
  }
  
  translate (0,0,yearMove);
  
  pushMatrix();
  
  int year = 2007;
  for (int i=0; i<13; i++) {
    noFill();
    stroke (255, 255);
    strokeWeight(1);
    //r=75*2;    
    ellipse(0, 0, r, r);
    strokeWeight(2);
    textFont(f, 5);
    fill(255);
    text (year, 2*r/3, 10, 10);
    year = year + 1;
    
    // Move onto the next ellipse
    translate (0, 0, -200);
  }
  
    
  popMatrix();
  
  pushMatrix();
  
  for (int i=0; i<13; i++) {
    totalPoints = new ArrayList<Point3d> ();
    rainPoints = new ArrayList<Point3d> ();
    waterPoints = new ArrayList<Point3d> ();
    riverPoints = new ArrayList<Point3d> ();
    lakePoints = new ArrayList<Point3d> ();
    seaPoints = new ArrayList<Point3d> ();
    oceanPoints = new ArrayList<Point3d> ();
    
   // Fill Data
    ArrayList<Day> currentArray = allArrays.get(i);
    int numRows = currentArray.size();
    for (int j=0; j < numRows; j++) {
      Day currentDay = currentArray.get(j);
      int dayOfYear = currentDay.dayOfYear;
      float precipitation = currentDay.precip;
      
      int totalCheckouts = currentDay.dayTotal;
      int rainCheckouts = currentDay.rain;
      int waterCheckouts = currentDay.water;
      int riverCheckouts = currentDay.river;
      int lakeCheckouts = currentDay.lake;
      int oceanCheckouts = currentDay.ocean;
      int seaCheckouts = currentDay.sea;
      
      
      stroke (255);
      strokeWeight (3);
      
      // Displays total
      // Max 417
      if (showTotal == true) {
        float dayAngle = map(dayOfYear, 1, 366, 0, TWO_PI);
        float precip = map (precipitation, 0, 2.75, 0, 100);
        float distance = map (totalCheckouts, 0, 420, 0, r/2);
     
        color c = colorDetermine("Total", totalCheckouts, 417, precip);
        stroke(c);
        float x = distance * cos(dayAngle);
        float y = distance * sin(dayAngle);
        float z = precip;
        point (x, y, z);
        totalPoints.add(new Point3d (x, y, z));
        
        displayInfo (x, y, z, totalCheckouts, precipitation);
        
      }
      
      // Displays rain
      // Max 34
      if (showRain == true) {
        float dayAngle = map(dayOfYear, 1, 366, 0, TWO_PI);
        float precip = map (precipitation, 0, 2.75, 0, 100);
        float distance = map (rainCheckouts, 0, 37, 0, r/2);
     
        color c = colorDetermine("Rain", rainCheckouts, 34, precip);
        stroke(c);
        float x = distance * cos(dayAngle);
        float y = distance * sin(dayAngle);
        float z = precip;
        point (x, y, z);
        rainPoints.add(new Point3d (x, y, z));
        
        displayInfo (x, y, z, rainCheckouts, precipitation);
      }
      
      // Displays water
      // Max 165
      if (showWater == true) {
        float dayAngle = map(dayOfYear, 1, 366, 0, TWO_PI);
        float precip = map (precipitation, 0, 2.75, 0, 100);
        float distance = map (waterCheckouts, 0, 170, 0, r/2);
     
        color c = colorDetermine("Water", waterCheckouts, 165, precip);
        stroke(c);
        float x = distance * cos(dayAngle);
        float y = distance * sin(dayAngle);
        float z = precip;
        point (x, y, z);
        waterPoints.add(new Point3d (x, y, z));
        
        displayInfo (x, y, z, waterCheckouts, precipitation);
      }
      
      // Displays River
      // Max 100
      if (showRiver == true) {
        float dayAngle = map(dayOfYear, 1, 366, 0, TWO_PI);
        float precip = map (precipitation, 0, 2.75, 0, 100);
        float distance = map (riverCheckouts, 0, 105, 0, r/2);
     
        color c = colorDetermine("River", riverCheckouts, 100, precip);
        stroke(c);
        float x = distance * cos(dayAngle);
        float y = distance * sin(dayAngle);
        float z = precip;
        point (x, y, z);
        riverPoints.add (new Point3d (x, y, z));
        
        displayInfo (x, y, z, riverCheckouts, precipitation);
      }
      
      // Displays Lake
      // Max 87
      if (showLake == true) {
        float dayAngle = map(dayOfYear, 1, 366, 0, TWO_PI);
        float precip = map (precipitation, 0, 2.75, 0, 100);
        float distance = map (lakeCheckouts, 0, 90, 0, r/2);
     
        color c = colorDetermine("Lake", lakeCheckouts, 87, precip);
        stroke(c);
        float x = distance * cos(dayAngle);
        float y = distance * sin(dayAngle);
        float z = precip;
        point (x, y, z);
        lakePoints.add (new Point3d (x, y, z));
        
        displayInfo (x, y, z, lakeCheckouts, precipitation);
      }
      
      // Displays Ocean
      // Max 88
      if (showOcean == true) {
        float dayAngle = map(dayOfYear, 1, 366, 0, TWO_PI);
        float precip = map (precipitation, 0, 2.75, 0, 100);
        float distance = map (oceanCheckouts, 0, 90, 0, r/2);
     
        color c = colorDetermine("Ocean", oceanCheckouts, 88, precip);
        stroke(c);
        float x = distance * cos(dayAngle);
        float y = distance * sin(dayAngle);
        float z = precip;
        point (x, y, z);
        oceanPoints.add (new Point3d (x, y, z));
        
        displayInfo (x, y, z, oceanCheckouts, precipitation);
      }
      
      // Displays Sea
      // Sea 106
      if (showSea == true) {
        float dayAngle = map(dayOfYear, 1, 366, 0, TWO_PI);
        float precip = map (precipitation, 0, 2.75, 0, 100);
        float distance = map (seaCheckouts, 0, 110, 0, r/2);
     
        color c = colorDetermine("Sea", seaCheckouts, 106, precip);
        stroke(c);
        float x = distance * cos(dayAngle);
        float y = distance * sin(dayAngle);
        float z = precip;
        point (x, y, z);
        seaPoints.add (new Point3d (x, y, z));
        
        displayInfo (x, y, z, seaCheckouts, precipitation);
      }
      
    
    }
    if (showTotal == true && showHull == true) {
      drawConvexHull(totalPoints);
      
    }
    
    if (showRain == true && showHull == true) {
      drawConvexHull(rainPoints);
    }
    
    if (showWater == true && showHull == true) {
      drawConvexHull(waterPoints);
    }
    
    if (showRiver == true && showHull == true) {
      drawConvexHull(riverPoints);
    }
    
    if (showLake == true && showHull == true) {
      drawConvexHull(lakePoints);
    }
    
    if (showOcean == true && showHull == true) {
      drawConvexHull(oceanPoints);
    }
    
    if (showSea == true && showHull == true) {
      drawConvexHull(seaPoints);
    }
    
    translate (0, 0, -200);
  }
  
  popMatrix();
  
}
