import newhull.*;

QuickHull3D hull = new QuickHull3D();
Point3d[] points;

ArrayList <Point3d> totalPoints; // = new ArrayList<Point3d> ();
ArrayList <Point3d> rainPoints; // = new ArrayList<Point3d> ();
ArrayList <Point3d> waterPoints; // = new ArrayList<Point3d> ();
ArrayList <Point3d> riverPoints; // = new ArrayList<Point3d> ();
ArrayList <Point3d> lakePoints; // = new ArrayList<Point3d> ();
ArrayList <Point3d> seaPoints; // = new ArrayList<Point3d> ();
ArrayList <Point3d> oceanPoints; // = new ArrayList<Point3d> ();

void drawConvexHull (ArrayList<Point3d> allPoints) {
  
  //size(800, 800, P3D);
  
  points = new Point3d[allPoints.size()];
  for (int i = 0; i < allPoints.size(); i++) {
    points[i] = allPoints.get(i);
  }
  
  
  int numPoints = points.length;
  
  if (hull.myCheck(points, numPoints) == true) {
    hull.build(points);
    hull.triangulate();
    Point3d[] vertices = hull.getVertices();
    
    strokeWeight (1);
    beginShape(TRIANGLE_STRIP);
    noFill();
    int[][] faceIndices = hull.getFaces();
    //run through faces (each point on each face), and draw them
    for (int i = 0; i < faceIndices.length; i++) {
      for (int k = 0; k < faceIndices[i].length; k++) {
 
        //get points that correspond to each face
        Point3d pnt2 = vertices[faceIndices[i][k]];
        float x = (float)pnt2.x;
        float y = (float)pnt2.y;
        float z = (float)pnt2.z;
        vertex(x,y,z);
      }
    }
    endShape(CLOSE);
    
  }
  
}
